#ifndef bqt_actmap_hh
#define bqt_actmap_hh

#include <vector>
#include <pair.h>

using std::vector;
using std::pair;

#include "channel.hh"
#include "agent.hh"
#include "list.hh"

#define C(ch, what) \
  protected: Lista<what> what##s; \
          inline unsigned ch##s() const { return what##s.Size(); } \
  public: void Add##what(const what &a) { what##s.Add(a); } \
          unsigned what##Index(const what &a) const { return what##s.Index(a); }

class ActMapBase
{
    C(A, Agent)
    C(C, Channel)

protected:
    Lista<pair<unsigned, unsigned> > agchan;
    vector<bool> map;
    
    bool DoMarkOp(unsigned ci, unsigned mi);
    unsigned MdInd(unsigned a, unsigned c, unsigned m) const;
    void Set(unsigned a, unsigned c, unsigned m);
    virtual unsigned Ms() const = 0;
    
public:
    virtual ~ActMapBase();
    void SetAgentChan(const Agent &ag, const Channel &ch);

    void InitMap();
    virtual void Distribute() = 0;
};

template<class Op>
class ActMap : public ActMapBase
{
    C(M, Op)
    
public:
    void SetChanOp(const Channel &ch, const Op &md);
    virtual void Distribute();
};

#undef C

#include "actmap.tcc"

#endif
